**
** main.s ( FPSP.X C[` )
** programmed by yamapu in 1994
**
** modified by mor 2001.5.10(Thu)
**	68000  DEVICE= Ɏw肷Ɩ\Ă̂C
**	DEVICE= NŃG[oꍇ͓o^Ȃ悤ɕύX
**

	.cpu	68040

	.include iocscall.mac
	.include doscall.mac

*
* \}N
*
PRINT	.macro	label
	move.l	d0,-(sp)
	pea.l	label
	DOS	_PRINT
	addq.l	#4,sp
	move.l	(sp)+,d0
	.endm

	.xref	GetToken
	.xref	CompareStrings

	.text
	.even
driverStart:

*
* foCXwb_
*
	.text
	.even
deviceHeader:
	.dc.l	-1
	.dc.w	$8000
	.dc.l	StrategyRoutine
	.dc.l	InterruptRoutine
	.dc.b	1,'FPSP   '

*
* XgeW[`
*
	.text
	.even
StrategyRoutine:
	move.l	a5,requestHeader
	rts

*
* 荞݃[`
*
	.text
	.even
InterruptRoutine:
	movem.l	d1/a5,-(sp)
	move.l	(requestHeader,pc),a5
	move.b	(2,a5),d0
	sne	d0		* d0.b = d0.b ? $FF : 0;
	ext.w	d0		* CommandTable PԒn҂i΁j
	move.b	(CommandTable,pc,d0.w),d0
	jsr	(CommandTable,pc,d0.w)
	move.l	d0,d1
	move.b	d1,(3,a5)			*** G[R[h ( low )
	lsr.w	#8,d1
	move.b	d1,(4,a5)			*** G[R[h ( high )
	movem.l	(sp)+,d1/a5
	rts

requestHeader:
	.dc.l	0

	dc.b	IllegalCommandRoutine-CommandTable
CommandTable:
	dc.b	InitializeRoutine-CommandTable
	.even

*
* sR}h[`
*
	.text
	.even
not68040:				*  - 68040 łȂ
	PRINT	not68040Message
errorTemination:			*  - IvVs
IllegalCommandRoutine:
	move.w	#$5003,d0			*** R}hR[hG[i~Â݁j
	rts

*
* [`ixN^ݒj
*
	.text
	.even
InitializeRoutine:
	PRINT	titleMessage
	cmp.b	#$04,$0cbc.w
	bne	not68040				*** 68040 łȂȂXLbv
	bsr	AnalizeOption				*** IvV
	tst.l	d0
	bne	errorTemination
	bsr	SetVector				*** xN^ݒ
	moveq.l	#0,d0
	move.l	#driverEnd,(14,a5)
	rts

*
* VF̎s
*
	.text
	.even
XentryPoint:
	move.l	a1,-(sp)
	clr.l	a1
	IOCS	_B_SUPER
	move.l	(sp)+,a1
	PRINT	xTitleMessage
	bsr	XanalizeOption				*** IvV
	tst.l	d0
	bne	xErrorTermination
	tst.b	helpFlag				*** wv\H
	bne	xNormalTermination
	cmp.b	#$04,$0cbc.w				*** 68040 ǂ`FbN
	bne	xNot68040

	bsr	KeepCheck				*** 풓`FbN -> d0
	tst.l	d0
	beq	notKept
*** 풓Ă
	tst.b	releaseFlag				*** -r IvV肩H
	beq	keepAlreadyKeptDriver
	bsr	ReleaseDriver				*** 
	tst.l	d0
	beq	releaseComplete
	PRINT	cannotReleaseMessage			*** 풓łȂ
	bra	xErrorTermination
releaseComplete:
	PRINT	releaseMessage
	bra	xNormalTermination
*** 풓ĂȂ
	.xdef	notKept
notKept:
	tst.b	releaseFlag				*** -r IvV肩H
	bne	releaseNotKeptDriver
	bsr	SetVector				*** xN^ݒ
	PRINT	keepMessage
	clr.w	-(sp)
	move.l	#driverEnd-driverStart,-(sp)
	DOS	_KEEPPR					*** 풓

xNormalTermination:
	move.w	#0,-(sp)
	DOS	_EXIT2					*** I

xNot68040:
	PRINT	not68040Message				*** 68040 ł͂Ȃ
	bra	xErrorTermination
keepAlreadyKeptDriver:
	PRINT	alreadyKeptMessage			*** łɏ풓Ă
	bra	xErrorTermination
cannotRelease:
	PRINT	cannotReleaseMessage			*** 풓s\
	bra	xErrorTermination
releaseNotKeptDriver:
	PRINT	notKeptMessage				*** 풓ĂȂ̂ɉ悤Ƃ
xErrorTermination:
	move.w	#-1,-(sp)
	DOS	_EXIT2					*** G[I

	.data
	.even
keepMessage:
	.dc.b	'풓܂B',13,10,0
alreadyKeptMessage:
	.dc.b	'łɏ풓Ă܂B',13,10,0
releaseMessage:
	.dc.b	'풓܂B',13,10,0
cannotReleaseMessage:
	.dc.b	'풓ł܂łB',13,10,0
notKeptMessage:
	.dc.b	'풓Ă܂B',13,10,0

titleMessage:
	.dc.b	13,10
xTitleMessage:
	.dc.b	'M68040 Software Package Copyright (c) 1993, 1994 Motorola Inc.',13,10
	.dc.b	'modified version 1.01 on JUPITER-X, 040TURBO by yamapu in 1994',13,10
	.dc.b	'                 1.01+1 on JUPITER-X, 040TURBO and 0x0Excel by mor 2001',13,10,0

not68040Message:
	.dc.b	'68040 ł͂܂B',13,10,0


*
* IvV ( foCXhCoN )
*
	.text
	.even
AnalizeOption:
	movem.l	a0-a4,-(sp)
	move.l	(18,a5),a0				*** a0 = p[^

analizeOptionLoop:
skipParameter:
	tst.b	(a0)+
	bne	skipParameter
	move.l	a0,a1
	tst.b	(a1)
	beq	endAnalizeOption			*** R}hCI[ȂI
	cmp.b	#'-',(a1)
	bne	notOption
	addq.l	#1,a1
	lea.l	optionTable,a2
	lea.l	optionRoutineTable,a3
	bsr	callOptionRoutine			*** IvṼ[`Ă
	tst.l	d0
	bne	optionError
	bra	analizeOptionLoop
notOption:
	PRINT	commandLineErrorMessage			*** IvVł͂Ȃ΃G[
	PRINT	helpMessage
	bra	analizeOptionError

*
* IvV ( VFN )
*
	.text
	.even
XanalizeOption:
	movem.l	a0-a4,-(sp)
	move.l	a2,a0
	addq.l	#1,a0					*** a0 = R}hC

xAnalizeOptionLoop:
	bsr	GetToken				*** IvV擾
	tst.b	(a1)
	beq	endAnalizeOption			*** R}hCI[ȂI
	cmp.b	#'-',(a1)
	bne	xNotOption
	addq.l	#1,a1
	lea.l	xOptionTable,a2
	lea.l	xOptionRoutineTable,a3
	bsr	callOptionRoutine			*** IvṼ[`Ă
	tst.l	d0
	bne	optionError
	bra	xAnalizeOptionLoop
xNotOption:
	PRINT	commandLineErrorMessage			*** IvVł͂Ȃ΃G[
	PRINT	helpMessage
	bra	analizeOptionError

*** IvṼ[`Ă
callOptionRoutine:
	move.l	(a3)+,a4				*** [`擾
	move.b	(a2)+,d0
	beq	callOptionRoutineError
	cmp.b	(a1),d0					*** IvVr
	bne	callOptionRoutine
	addq.l	#1,a1
	jsr	(a4)
	rts
callOptionRoutineError:
	moveq.l	#-1,d0
	rts

optionError:
	PRINT	illegalOptionErrorMessage		*** sIvV
	PRINT	helpMessage
	bra	analizeOptionError

endAnalizeOption:
	moveq.l	#0,d0					*** I
	movem.l	(sp)+,a0-a4
	rts
analizeOptionError:
	moveq.l	#-1,d0					*** G[I
	movem.l	(sp)+,a0-a4
	rts


	.data
	.even
xOptionTable:
	.dc.b	'?','h','H'
	.dc.b	'r','R'
optionTable:
	.dc.b	0
	.even
xOptionRoutineTable:
	.dcb.l	3,helpOptionRoutine
	.dcb.l	2,setReleaseFlag
optionRoutineTable:

commandLineErrorMessage:
	.dc.b	'R}hCłB',13,10,0
illegalOptionErrorMessage:
	.dc.b	'IvVw肪słB',13,10,0


*
* IvV '?', 'h', 'H' wv\
*
	.text
	.even
helpOptionRoutine:
	st.b	helpFlag
	PRINT	helpMessage
	moveq.l	#0,d0
	rts

	.data
	.even
helpFlag:
	.dc.b	0
helpMessage:
	.dc.b	13,10
	.dc.b	'gp@:   device = fpsp.x   ( config.sys  )',13,10
	.dc.b	'            fpsp.x [-rRhH?]   ( R}h )',13,10
	.dc.b	'IvV: -h, -H, -?  ̃bZ[Wo͂܂B',13,10
	.dc.b	'            -r, -R      풓܂B',13,10,0
	.dc.b	0


*
* IvV 'r', 'R' 풓tOZbg
*
	.text
	.even
setReleaseFlag:
	st.b	releaseFlag
	moveq.l	#0,d0
	rts

	.data
	.even
releaseFlag:
	.dc.b	0


*
* xN^ݒ
*
	.text
	.even
SetVector:
	movem.l	d0/a0-a2,-(sp)
	lea.l	vectorNumberTable,a0
	lea.l	vectorTable,a1
	lea.l	originalVectorTable,a2
setVectorLoop:
	move.w	(a0)+,d0				*** d0 = xN^ԍ
	beq	endSetVector
	move.l	(a1)+,-(sp)
	move.w	d0,-(sp)
	DOS	_INTVCS					*** xN^ݒ
	addq.l	#6,sp
	move.l	d0,(a2)+				*** ̃xN^ۑ
	bra	setVectorLoop
endSetVector:
	movem.l	(sp)+,d0/a0-a2
	rts

*
* xN^A
*
	.text
	.even
RecoverVector:
	movem.l	d0/a0-a1,-(sp)
	lea.l	vectorNumberTable,a0
	move.l	keepingProcessMemory,a1
	add.l	#$0100+originalVectorTable-driverStart,a1
recoverVectorLoop:
	move.w	(a0)+,d0				*** d0 = xN^ԍ
	beq	endRecoverVector
	move.l	(a1)+,-(sp)
	move.w	d0,-(sp)
	DOS	_INTVCS					*** xN^A
	addq.l	#6,sp
	bra	recoverVectorLoop
endRecoverVector:
	movem.l	(sp)+,d0/a0-a1
	rts

*
* xN^`FbN
*
	.text
	.even
CheckVector:
	movem.l	a0-a1,-(sp)
	lea.l	vectorNumberTable,a0
	move.l	keepingProcessMemory,a1
	add.l	#$0100+vectorTable-driverStart,a1
checkVectorLoop:
	move.w	(a0)+,d0
	beq	endCheckVector
	move.w	d0,-(sp)
	DOS	_INTVCG					*** xN^擾
	addq.l	#2,sp
	cmp.l	(a1)+,d0				*** 풓hCô̂Ɣr
	beq	checkVectorLoop
checkVectorError:
	movem.l	(sp)+,a0-a1
	moveq.l	#-1,d0
	rts
endCheckVector:
	movem.l	(sp)+,a0-a1
	moveq.l	#0,d0
	rts

FLINE_VEC	equ	$2c/4
BSUN_VEC	equ	$c0/4
INEX2_VEC	equ	$c4/4
DZ_VEC		equ	$c8/4
UNFL_VEC	equ	$cc/4
OPERR_VEC	equ	$d0/4
OVFL_VEC	equ	$d4/4
SNAN_VEC	equ	$d8/4
UNSUP_VEC	equ	$dc/4

	.xref	fline,unsupp
	.xref	bsun,inex,dz,unfl
	.xref	operr,ovfl,snan

	.data
	.even
vectorNumberTable:
	.dc.w	FLINE_VEC
	.dc.w	BSUN_VEC
	.dc.w	INEX2_VEC
	.dc.w	DZ_VEC
	.dc.w	UNFL_VEC
	.dc.w	OPERR_VEC
	.dc.w	OVFL_VEC
	.dc.w	SNAN_VEC
	.dc.w	UNSUP_VEC
	.dc.w	0

vectorTable:
	.dc.l	fline
	.dc.l	bsun
	.dc.l	inex
	.dc.l	dz
	.dc.l	unfl
	.dc.l	operr
	.dc.l	ovfl
	.dc.l	snan
	.dc.l	unsupp

originalVectorTable:
	.xdef	originalFline
originalFline:
	.dc.l	0
	.dcb.l	8,0


*
* 풓`FbN
*
	.text
	.even
KeepCheck:
	movem.l	a0-a4,-(sp)
	move.l	a0,a2
	move.l	a0,a3
	lea.l	($c4,a0),a4

*** T
findBackwardLoop:
	move.l	($0c,a2),d0
	beq	endFindingBackward
	move.l	d0,a2					*** ̃Ǘ|C^
	lea.l	($c4,a2),a0				*** t@Cł͂̏ꏊ
	move.l	a4,a1					*** ̃vZX̃t@C
	bsr	CompareStrings
	tst.l	d0
	bne	findBackwardLoop
	lea.l	($100+identifyString-driverStart,a2),a0	*** ʕł͂̂̏ꏊ
	lea.l	identifyString,a1			*** ʕ
	bsr	CompareStrings
	tst.l	d0
	bne	findBackwardLoop
	bra	foundKeepingDriver
endFindingBackward:

*** OT
findForwardLoop:
	move.l	(a2),d0
	beq	notFound
	move.l	d0,a2					*** ̃Ǘ|C^
	lea.l	($c4,a2),a0				*** t@Cł͂̏ꏊ
	move.l	a4,a1					*** ̃vZX̃t@C
	bsr	CompareStrings
	tst.l	d0
	bne	findForwardLoop
	lea.l	($100+identifyString-driverStart,a2),a0	*** ʕł͂̂̏ꏊ
	lea.l	identifyString,a1			*** ʕ
	bsr	CompareStrings
	tst.l	d0
	bne	findForwardLoop

foundKeepingDriver:
	move.l	a2,keepingProcessMemory			*** Ǘ|C^ۑ
	moveq.l	#-1,d0
	movem.l	(sp)+,a0-a4
	rts
notFound:
	moveq.l	#0,d0
	movem.l	(sp)+,a0-a4
	rts

	.data
	.even
keepingProcessMemory
	.dc.l	0
	.text
	.even
identifyString:
	.dc.b	'M68040 Software Package (C) Motolora Inc.',0

*
* 풓
*
	.text
	.even
ReleaseDriver:
	bsr	CheckVector				*** xN^`FbN
	tst.l	d0
	bne	vectorChanged
	bsr	RecoverVector				*** xN^A
	move.l	keepingProcessMemory,d0
	add.l	#16,d0
	move.l	d0,-(sp)
	DOS	_MFREE					*** 풓vZX
	addq.l	#4,sp
	moveq.l	#0,d0
	rts
vectorChanged:
	PRINT	vectorChangeMessage
	moveq.l	#-1,d0
	rts

	.data
	.even
vectorChangeMessage:
	.dc.b	'xN^Ă܂B',13,10,0


	.stack
	.even
driverEnd:

	.end	XentryPoint


